if RFirst then
    RFirst = 1;
else
    RFirst = 2;
end

if RFirst == 2 then
    RCount = 1;
end

if RFirst == 1 then
    RCount = RCount+1;
end

if RCount > 2 then
    RCount = 1
end

switch RCount 
    case 1
        require "import"
        import "android.content.Context"
        import "android.os.Vibrator"
        import "java.io.File"
        import "java.text.SimpleDateFormat"
        import "java.util.Date"
        import "android.media.MediaRecorder"

        local folderName = "MP3_Recordings"
        local folderPath = "/storage/emulated/0/" .. folderName
        local folder = File(folderPath)
        if not folder.exists() then
            local success = folder.mkdirs()
            if success then
                service.asyncSpeak("Folder created: " .. folderPath)
            else
                service.asyncSpeak("Could not create the folder at: " .. folderPath)
            end
        end

        local dateFormat = SimpleDateFormat("HH_mm_ss", Locale.getDefault())
        local currentTime = dateFormat.format(Date())
        local outputFile = folderPath .. "/recorded_audio_" .. currentTime .. ".mp3"

        local mediaRecorder = MediaRecorder()
        mediaRecorder.setAudioSource(MediaRecorder.AudioSource.MIC)
        mediaRecorder.setOutputFormat(MediaRecorder.OutputFormat.THREE_GPP) -- Use a format compatible with stereo recording
        mediaRecorder.setAudioEncoder(MediaRecorder.AudioEncoder.AAC)
        mediaRecorder.setAudioEncodingBitRate(128000)
        mediaRecorder.setAudioChannels(2) -- Set the audio channels to stereo
        mediaRecorder.setAudioSamplingRate(44100) -- Set the sampling rate to 44.1 kHz for medium quality
        mediaRecorder.setOutputFile(outputFile)

        local isRecording = false

        function stopRecording()
            if isRecording then
                mediaRecorder.stop()
                mediaRecorder.release()
                mediaRecorder = nil
                isRecording = false
            end
        end

        function startRecording()
            if not isRecording then
                mediaRecorder.prepare()
                mediaRecorder.start()
                isRecording = true
            end
        end

        startRecording()

        local context = activity or service
        local vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)
        if vibrator.hasVibrator() then
            vibrator.vibrate(100)
        end

        return true

    case 2
        stopRecording()
        service.asyncSpeak("Recording finished")
        require "import"
        import "android.content.Context"
        import "android.os.Vibrator"
        local context = activity or service
        local vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)
        if vibrator.hasVibrator() then
            vibrator.vibrate(200)
        end
        return true
end
return true
